// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice-E is licensed to you under the terms described in the
// ICEE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice-E version 1.1.0
// Generated from file `RouterF.ice'

#ifndef __IceE_RouterF_h__
#define __IceE_RouterF_h__

#include <IceE/LocalObjectF.h>
#include <IceE/ProxyF.h>
#ifndef ICEE_PURE_CLIENT
#  include <IceE/ObjectF.h>
#endif
#include <IceE/Exception.h>
#include <IceE/LocalObject.h>
#include <IceE/Proxy.h>
#include <IceE/UndefSysMacros.h>

#ifndef ICEE_IGNORE_VERSION
#   if ICEE_INT_VERSION / 100 != 101
#       error IceE version mismatch!
#   endif
#   if ICEE_INT_VERSION % 100 < 0
#       error IceE patch level mismatch!
#   endif
#endif

#ifndef ICE_API
#   ifdef ICE_API_EXPORTS
#       define ICE_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Ice
{

class Router;
ICE_API bool operator==(const Router&, const Router&);
ICE_API bool operator!=(const Router&, const Router&);
ICE_API bool operator<(const Router&, const Router&);

}

}

namespace Ice
{

#ifndef ICEE_PURE_CLIENT

class Router;
ICE_API bool operator==(const Router&, const Router&);
ICE_API bool operator!=(const Router&, const Router&);
ICE_API bool operator<(const Router&, const Router&);

#endif // ICEE_PURE_CLIENT

}

namespace IceInternal
{

#ifndef ICEE_PURE_CLIENT

ICE_API void incRef(::Ice::Router*);
ICE_API void decRef(::Ice::Router*);

#endif // ICEE_PURE_CLIENT

ICE_API void incRef(::IceProxy::Ice::Router*);
ICE_API void decRef(::IceProxy::Ice::Router*);

}

namespace Ice
{

#ifndef ICEE_PURE_CLIENT

typedef ::IceInternal::Handle< ::Ice::Router> RouterPtr;

#endif // ICEE_PURE_CLIENT

typedef ::IceInternal::ProxyHandle< ::IceProxy::Ice::Router> RouterPrx;

ICE_API void __write(::IceInternal::BasicStream*, const RouterPrx&);
ICE_API void __read(::IceInternal::BasicStream*, RouterPrx&);

}

namespace Ice
{

}

namespace IceProxy
{

namespace Ice
{

}

}

#endif
